import processing.core.PApplet;
import processing.core.PImage;

/**
 * integration Example APARAPI-PROCESSING
 * 
 * @author edumo.net
 * 
 */

public class TestAparapiP5 extends PApplet {

	LifeKernelP5 lifeKernel;
	PImage img = null;

	long generations = 0;
	long start = System.currentTimeMillis();

	public void setup() {
		size(1366, 768);

		background(0);

		fill(255);
		rect(0, height / 2, width, 200);

		loadPixels();

		//REMEMBER, EVERY OBJECT IS A POINTER!! pixels is the processing frame buffer.
		this.lifeKernel = new LifeKernelP5(width, height, pixels);
		// lifeKernel.setExecutionMode(EXECUTION_MODE.CPU);
		System.out.println("Execution mode = " + lifeKernel.getExecutionMode());

		updatePixels();
	}

	public static final int clip(int a, int min, int max) {
		return a < min ? min : (a > max ? max : a);
	}

	public void setRect(int x, int y, int w, int h, int[] pixels, int color) {

		int mix = clip(x - w / 2, 0, width);
		int max = clip(x + w / 2, 0, width);
		int miy = clip(y - h / 2, 0, height);
		int may = clip(y + h / 2, 0, height);

		for (int yy = miy; yy < may; yy++) {
			for (int xx = mix; xx < max; xx++) {
				int idx = yy * width + xx;
				pixels[idx] = color;
			}
		}
	}

	public void draw() {

		if (mousePressed) {
			setRect(mouseX, mouseY, 10, 10, pixels, color(255));
		}

		lifeKernel.nextGeneration(); // Work is performed here

		//update the pixels because aparapi has changed it
		updatePixels();
		
		fill(0);
		rect(0, 0, 100, 20);
		fill(255);
		text(frameRate, 10, 10);
	}

	static public void main(String args[]) {
		PApplet.main(new String[] { "--bgcolor=#F0F0F0", "TestAparapiP5" });
	}
}
